package oop2_dat2_u;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class Ringbuffer
{

    private int size;
    private int nbrElt = 0;
    private int in = 0;
    private int out = 0;
    private Object[] queue;

    public Ringbuffer(int s)
    {
        size = s;
        queue = new Object[size];
    }

    public void enqueue(Object o)
    {
        // Fügt x am Ende in die Warteschlange ein,
        // falls die Warteschlange nicht voll ist;
        nbrElt ++;
        if (in == size) {
            in = 0;
        }
        queue[in] = o;
        in ++;
    }

    public Object dequeue()
    {
        // Entfernt das erste Element aus der Warteschlange,
        // falls die Warteschlange nicht leer ist;
        nbrElt --;
        if (out == size) {
            out = 0;
        }
        Object o = queue[out];
        out ++;
        return o;
    }

    public boolean isEmpty()
    {
        //liefert true genau dann, wenn die Warteschlange kein Element enthält
        return (nbrElt == 0);
    }

    public boolean isFull()
    {
        //liefert true genau dann, wenn die Warteschlange voll ist
        return (nbrElt == size);
    }

    /**
     * @return the nbrElt
     */
    public int getNumberElements()
    {
        return nbrElt;
    }
}
